/****************************************************************************\
*                                                                            *
*  MONOMAP.CPP                                                               *
*  MONOMAPU.CPP                                                              *
*                                                                            *
*  This program demonstrates the Fastgraph for Windows monochrome bitmap     *
*  display functions.                                                        *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "MonomapU.h"

char hello[] = {
   0x00,0x00,0x00,0x00,0x00,
   0xCC,0x78,0x78,0x78,0x78,
   0xCC,0xC0,0x30,0x30,0xCC,
   0xCC,0xFC,0x30,0x30,0xCC,
   0xFC,0xCC,0x30,0x30,0xCC,
   0xCC,0x78,0x30,0x30,0x78,
   0xCC,0x00,0x30,0x30,0x00,
   0xCC,0x00,0x70,0x70,0x00};

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
    WIDTH(320),
    HEIGHT(200)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb);
   fg_vbcolors();

   fg_setcolor(25);
   fg_fillpage();

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::drawmap1Click(TObject *Sender)
{
   fg_setcolor(25);
   fg_fillpage();
   fg_setcolor(10);
   fg_move(WIDTH/2-20,HEIGHT/2+4);
   fg_drawmap(hello,5,8);
   fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::clipmap1Click(TObject *Sender)
{
   fg_setcolor(25);
   fg_fillpage();
   fg_setcolor(22);
   fg_move(-12,HEIGHT/2+4);
   fg_clipmap(hello,5,8);
   fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Quit1Click(TObject *Sender)
{
   Application->Terminate();
}
//---------------------------------------------------------------------------
