VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   Caption         =   "Panning Demo"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6690
   Height          =   4830
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.Menu mnuLeft
      Caption         =   "&Left"
      Enabled         =   0   'False
   End
   Begin VB.Menu mnuRight
      Caption         =   "&Right"
   End
   Begin VB.Menu mnuUp
      Caption         =   "&Up"
      Enabled         =   0   'False
   End
   Begin VB.Menu mnuDown
      Caption         =   "&Down"
   End
   Begin VB.Menu mnuReset
      Caption         =   "R&eset"
   End
   Begin VB.Menu mnuQuit
      Caption         =   "&Quit"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  PANNER.FRM                                                                *
'                                                                            *
'  This program shows how to pan the contents of a virtual buffer through    *
'  a smaller window.                                                         *
'                                                                            *
'*****************************************************************************

Const vbWidth = 640
Const vbHeight = 480

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long

Dim X As Long, Y As Long
Dim xLimit As Long, yLimit As Long

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call fg_showbmp("PORCH.BMP", 0)
   X = 0
   Y = 0
End Sub

Private Sub Form_Paint()
   Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   If cxClient < vbWidth Then
      xLimit = vbWidth - cxClient
      If X > 0 Then mnuLeft.Enabled = True
      If X < xLimit Then mnuRight.Enabled = True
   Else
      xLimit = 0
      mnuLeft.Enabled = False
      mnuRight.Enabled = False
   End If
   If cyClient < vbHeight Then
      yLimit = vbHeight - cyClient
      If Y > 0 Then mnuUp.Enabled = True
      If Y < yLimit Then mnuDown.Enabled = True
   Else
      yLimit = 0
      mnuUp.Enabled = False
      mnuDown.Enabled = False
   End If
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub

Private Sub mnuLeft_Click()
   If X = xLimit Then mnuRight.Enabled = True
   X = X - 1
   Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
   If X = 0 Then mnuLeft.Enabled = False
End Sub

Private Sub mnuRight_Click()
   If X = 0 Then mnuLeft.Enabled = True
   X = X + 1
   Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
   If X = xLimit Then mnuRight.Enabled = False
End Sub

Private Sub mnuUp_Click()
   If Y = yLimit Then mnuDown.Enabled = True
   Y = Y - 1
   Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
   If Y = 0 Then mnuUp.Enabled = False
End Sub

Private Sub mnuDown_Click()
   If Y = 0 Then mnuUp.Enabled = True
   Y = Y + 1
   Call fg_vbpaste(X, X + (vbWidth - 1), Y, Y + (vbHeight - 1), 0, vbHeight - 1)
   If Y = yLimit Then mnuDown.Enabled = False
End Sub

Private Sub mnuReset_Click()
   X = 0
   Y = 0
   Call fg_vbpaste(0, vbWidth - 1, 0, vbHeight - 1, 0, vbHeight - 1)
   If xLimit > 0 Then mnuRight.Enabled = True
   If yLimit > 0 Then mnuDown.Enabled = True
   mnuLeft.Enabled = False
   mnuUp.Enabled = False
End Sub

Private Sub mnuQuit_Click()
   Unload Me
End Sub
