/****************************************************************************\
*                                                                            *
*  STRING2.CPP                                                               *
*  STRING2U.CPP                                                              *
*                                                                            *
*  This program shows how to display strings in a virtual buffer. If you     *
*  compile this as a Win16 program, you must link with Fastgraph's WinG      *
*  libraries.                                                                *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "String2U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
      WIDTH(320),
      HEIGHT(240)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb);
   fg_vbcolors();

   fg_setcolor(24);
   fg_fillpage();
   fg_setcolor(19);
   fg_fontdc(fg_getdc());

   // upper vertical justification
   fg_move(0,0);
   fg_justify(-1,1);
   fg_print("FG/Windows",10);
   fg_move(WIDTH/2,0);
   fg_justify(0,1);
   fg_print("FG/Windows",10);
   fg_move(WIDTH-1,0);
   fg_justify(1,1);
   fg_print("FG/Windows",10);

   // centered vertical justification
   fg_move(0,HEIGHT/2);
   fg_justify(-1,0);
   fg_print("FG/Windows",10);
   fg_move(WIDTH/2,HEIGHT/2);
   fg_justify(0,0);
   fg_print("FG/Windows",10);
   fg_move(WIDTH-1,HEIGHT/2);
   fg_justify(1,0);
   fg_print("FG/Windows",10);

   // lower vertical justification
   fg_move(0,HEIGHT-1);
   fg_justify(-1,-1);
   fg_print("FG/Windows",10);
   fg_move(WIDTH/2,HEIGHT-1);
   fg_justify(0,-1);
   fg_print("FG/Windows",10);
   fg_move(WIDTH-1,HEIGHT-1);
   fg_justify(1,-1);
   fg_print("FG/Windows",10);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
