!*****************************************************************************
!                                                                            *
!  SWCHARS.F90                                                               *
!                                                                            *
!  This program displays all characters in the Fastgraph for Windows primary *
!  and alternate software fonts.                                             *
!                                                                            *
!*****************************************************************************

integer*4 function WinMain (hInstance, hPrevInstance, lpszCmdParam, nCmdShow)
!MS$ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
use msfwina
use fgwin

interface
integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
integer*4 window, message, wParam, lParam
end function WindowProc
end interface

integer*4 hInstance, hPrevInstance, lpszCmdParam, nCmdShow

include 'swchars.fi'

character*12      AppName
integer*4         iret
integer*4         window
type (T_MSG)      msg
type (T_WNDCLASS) wndclass

data AppName /'FGswchars'C/

if (hPrevInstance == 0) then
   wndclass%style         = CS_HREDRAW .or. CS_VREDRAW .or. CS_OWNDC
   wndclass%lpfnWndProc   = LOC(WindowProc)
   wndclass%cbClsExtra    = 0
   wndclass%cbWndExtra    = 0
   wndclass%hInstance     = hInstance
   wndclass%hIcon         = LoadIcon(NULL,IDI_APPLICATION)
   wndclass%hCursor       = LoadCursor(NULL,IDC_ARROW)
   wndclass%hbrBackground = NULL
   wndclass%lpszMenuName  = NULL
   wndclass%lpszClassName = LOC(AppName)
   iret = RegisterClass(wndclass)
   lpszCmdParam = lpszCmdParam
end if

window = CreateWindow(      &
   AppName,                 &  ! window class name
   'Software Character Set'C,& ! window caption
   WS_OVERLAPPEDWINDOW,     &  ! window style
   CW_USEDEFAULT,           &  ! initial x position
   CW_USEDEFAULT,           &  ! initial y position
   WIDTH,                   &  ! initial x size
   HEIGHT,                  &  ! initial y size
   NULL,                    &  ! parent window handle
   NULL,                    &  ! window menu handle
   hInstance,               &  ! program instance handle
   NULL)                       ! creation parameters

iret = ShowWindow(window,nCmdShow)
iret = UpdateWindow(window)

do while (GetMessage(msg,NULL,0,0))
   iret = TranslateMessage(msg)
   iret = DispatchMessage(msg)
end do

WinMain = msg%wParam
return
end

!*****************************************************************************
!                                                                            *
!  WindowProc                                                                *
!                                                                            *
!  Window procedure to handle messages sent to the window.                   *
!                                                                            *
!*****************************************************************************

integer*4 function WindowProc (window, message, wParam, lParam)
!MS$ATTRIBUTES STDCALL, ALIAS:'_WindowProc@16' :: WindowProc
use msfwina
use fgwin
integer*4 window, message, wParam, lParam

include 'swchars.fi'

type (T_PAINTSTRUCT) ps
integer*4 xdest, ydest
integer*4 hdc, hpal, hvb
integer*4 iret

save xdest, ydest, hdc, hpal, hvb

WindowProc = 0

select case (message)

   case (WM_CREATE)
      hdc = GetDC(window)
      call fg_setdc(hdc)
      hpal = fg_defpal()
      call fg_realize(hpal)

      call fg_vbinit
      hvb = fg_vballoc(WIDTH,HEIGHT)
      iret = fg_vbopen(hvb)
      call fg_vbcolors

      call fg_initw
      call fg_setworld(0.0,6.39,0.0,4.79)
      call fg_setsizew(0.2)

      call fg_setcolor(25)
      call fg_fillpage
      call fg_setcolor(19)
      call fg_movew(3.2,4.2)
      call fg_swchar('Software characters - font 1'C,28,0)
      call fg_setcolor(10)
      call fg_movew(0.5,3.9)
      call fg_swchar('ABCDEFGHIJKLMNOPQRSTUVWXYZ'C,26,-1)
      call fg_movew(0.5,3.6)
      call fg_swchar('abcdefghijklmnopqrstuvwxyz'C,26,-1)
      call fg_movew(0.5,3.3)
      call fg_swchar('0123456789'C,10,-1)
      call fg_movew(0.5,3.0)
      call fg_swchar('!"#$%&=''()*+,-./:;<=>?[]^`{|}~'C,29,-1)

      call fg_setcolor(19)
      call fg_movew(3.2,2.5)
      call fg_swchar('Software characters - font 2'C,28,0)
      call fg_setcolor(10)
      call fg_movew(0.5,2.2)
      call fg_swchar('\\ABCDEFGHIJKLMNOPRSTUWXYZ'C,25,-1)
      call fg_movew(0.5,1.9)
      call fg_swchar('\\abcdefghijklmnoprstuwxyz'C,25,-1)
      call fg_movew(0.5,1.3)
      call fg_swchar('\\012345678#$%&()*+/<=>?[]{}'C,27,-1)

      call fg_setratio(1.2)
      call fg_movew(0.5,0.6)
      call fg_swchar('cos\\^2\\h\\+sin\\^2\\h\\=1'C,21,-1)

      call fg_movew(5.9,0.6)
      call fg_swchar('H\\v2O U\\v2\\v3\\v2'C,16,1)

      call fg_setratio(1.0)
      call fg_movew(3.2,0.2)
      call fg_swchar('One _word_ is underlined.'C,25,0)

      call fg_setcolor(19)
      call fg_movew(0.0,2.8)
      call fg_draww(6.39,2.8)
      call fg_movew(0.0,0.9)
      call fg_draww(6.39,0.9)
      return

   case (WM_PAINT)
      iret = BeginPaint(window,ps)
      call fg_vbpaste(0,WIDTH-1,0,HEIGHT-1,xdest,ydest)
      iret = EndPaint(window,ps)
      return

   case (WM_SETFOCUS)
      call fg_realize(hpal)
      iret = InvalidateRect(window,NULL_RECT,.TRUE.)
      return

   case (WM_SIZE)
      xdest = (INT4(LOWORD(lParam)) - WIDTH) / 2
      ydest = (INT4(HIWORD(lParam)) - HEIGHT) / 2
      if (xdest < 0) xdest = 0
      if (ydest < 0) ydest = 0
      ydest = (INT4(HIWORD(lParam))-1) - ydest
      return

   case (WM_DESTROY)
      call fg_vbclose
      call fg_vbfree(hvb)
      call fg_vbfin
      iret = DeleteObject(hpal)
      iret = ReleaseDC(window,hdc)
      call PostQuitMessage(0)
      return

end select

WindowProc = DefWindowProc(window,message,wParam,lParam)
return
end
