/****************************************************************************\
*                                                                            *
*  VBDEMO.CPP                                                                *
*  VBDEMOU.CPP                                                               *
*                                                                            *
*  This program demonstrates how to copy the contents of one virtual buffer  *
*  to another, with and without transparent colors.                          *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "VBDemoU.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
    WIDTH(640),
    HEIGHT(480)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb2 = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb2);
   fg_vbcolors();
   hvb1 = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb1);
   fg_vbcolors();

   fg_setcolor(25);
   fg_fillpage();
   fg_setcolor(20);
   fg_rect(WIDTH/4,WIDTH*3/4,HEIGHT/4,HEIGHT*3/4);

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb1);
   fg_vbfree(hvb2);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Cut1Click(TObject *Sender)
{
   fg_vbcopy(0,WIDTH-1,0,HEIGHT-1,0,HEIGHT-1,hvb1,hvb2);
   fg_erase();
   fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
   Paste1->Enabled = True;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paste1Click(TObject *Sender)
{
   fg_tcdefine(25,1);
   fg_vbtccopy(0,WIDTH-1,0,HEIGHT-1,0,HEIGHT-1,hvb2,hvb1);
   fg_vbscale(0,WIDTH-1,0,HEIGHT-1,0,cxClient-1,0,cyClient-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Quit1Click(TObject *Sender)
{
   Application->Terminate();
}
//---------------------------------------------------------------------------
